#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>


FILE *datei,*ziel,*rdatei;
int size,lsize;	//laenge des akt. symbols, ..., der zeile
char *buffer;	//zeilenpuffer
char *symbol;	//puffer fr aktuelles symbol
int i;

BOOL getLine(FILE **handle)
{//liest eine ganze Zeile (bis '\n') aus der datei
  BYTE *zeichen;

  //lesepuffer fr ein zeichen anlegen und initialisieren
  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';

  //zeilenpuffer neu initialisieren
  *buffer = '\0';
  lsize = 0;

  //zeile aus der datei lesen... (abbrechen bei dateiende)
  if((fread(zeichen,sizeof(BYTE),1,*handle)) == 0)
    return(false);

  //zeichen fuer zeichen einlesen, bis zeilenende (\n) erreicht
  while(*zeichen != '\n')
  {
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    fread(zeichen,sizeof(BYTE),1,*handle);
  }

  //das letzte zeichen noch anfgen
  lsize++;
  buffer = (char *)realloc(buffer,lsize+1);
  strncat(buffer,(char *)zeichen,1);

  //leerzeilen und zeilen mit '(xxx)' (zyklen) weglesen
  while((strncmp(buffer,"\n",1) == 0) || (strncmp(buffer,"(",1) == 0))
  {
    *zeichen = '\0';
    *buffer = '\0';
    lsize = 0;
  
    //zeile aus der datei lesen... (abbrechen bei dateiende)
    if((fread(zeichen,sizeof(BYTE),1,*handle)) == 0)
      return(false);

    while(*zeichen != '\n')
    {
      lsize++;
      buffer = (char *)realloc(buffer,lsize+1);
      strncat(buffer,(char *)zeichen,1);
    
      //nchstes zeichen lesen
      fread(zeichen,sizeof(BYTE),1,*handle);
    }

    //das letzte zeichen noch anfgen
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
  }
  
  i = 0;
  free(zeichen);
  return(true);
}


BOOL scanLine()
{//liefert alles zwischen doppeltabs bzw. zeilenende (symbol)
  BYTE *zeichen;

  //temp. puffer anlegen
  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';
  
  //puffer neu initialisieren
  *symbol = '\0';
  size = 0;

  //erstes zeichen einlesen
  *zeichen = (BYTE)(*(buffer+i));

  //evtl. anzahl der aufrufe '(xxxx)' (mehrfach) weglesen
  if(*zeichen == '(')
  {
    i += 7;
    *zeichen = (BYTE)(*(buffer+i));
  }
  
  //abbruchbedingungen fr das einlesen
  while((*zeichen != '\t') && (i < lsize))
  {
    //zeichen im puffer zu symbol zusammensetzen
    size++;
    symbol = (char *)realloc(symbol,size+1);
    strncat(symbol,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    i++;
    *zeichen = (BYTE)(*(buffer+i));
  }

  //zweites tab bergehen
  i += 2;

  //printf("SYMBOL: %s\n",symbol);

  free(zeichen);
  return(true);
}


int main(int argc, char* argv[])
{
  char *statement;
  char *quelle;
  char *methode;
  char *syncquelle;
  char *syncmethode;
  int qsize=1,msize=1,sqsize=1,smsize=1;
  int dateiende=0;

  int debug=0;

  if(argc != 4)
  {
    printf("vergleich <quelldatei> <referenzdatei> <ausgabedatei>");
    return(0);
  }

	printf("VERGLEICH...");

  //quelldatei zum lesen ffnen
	if((datei=fopen(argv[1],"r")) == NULL)
	{ 
		printf("Fehler beim ffnen der Datei %s\n",argv[1]);
		return(-1);
	}

  //referenzdatei zum lesen ffnen
	if((rdatei=fopen(argv[2],"r")) == NULL)
	{ 
		printf("Fehler beim ffnen der Datei %s\n",argv[2]);
		return(-1);
	}

  //zieldatei zum schreiben ffnen
	if((ziel=fopen(argv[3],"w")) == NULL)
	{ 
		printf("Fehler beim ffnen der Datei %s\n",argv[3]);
		return(-1);
	}

  //zeilenpuffer einrichten
  buffer = (char *)malloc(1);
  *buffer = '\0';

  //symbolpuffer einrichten
  symbol = (char *)malloc(1);
  *symbol = '\0';
 
  //quelldatei zeilenweise mit der referenzdatei vergleichen
  while(getLine(&datei))
  {
    //zeit einlesen
    scanLine();

    //dateinamen einlesen und sichern
    scanLine();
    qsize = size;
    quelle = (char *)malloc(qsize+1);
    strncpy(quelle,symbol,qsize+1);

    //methodennamen einlesen und sichern
    scanLine();
    msize = size;
    methode = (char *)malloc(msize+1);
    strncpy(methode,symbol,msize+1);

    //zeile aus der referenzdatei einlesen
    if(getLine(&rdatei))
    {
      //zeit einlesen
      scanLine();

      //dateinamen einlesen und sichern
      scanLine();
      sqsize = size;
      syncquelle = (char *)malloc(sqsize+1);
      strncpy(syncquelle,symbol,sqsize+1);

      //methodennamen einlesen
      scanLine();
      smsize = size;
      syncmethode = (char *)malloc(smsize+1);
      strncpy(syncmethode,symbol,smsize+1);

      //vergleichen
      if((strcmp(syncquelle,quelle) != 0) || (strcmp(syncmethode,methode) != 0))
      {	//quelldatei und referenzdatei verschieden
		//datei-und methodennamen aus der quelldatei in die ausgabedatei schreiben
        statement = (char *)malloc(qsize+msize+5);
        *statement = '\0';
		strncat(statement,"\t\t",2);
        strncat(statement,quelle,qsize);
        strncat(statement,"\t\t",2);
        strncat(statement,methode,msize);
        fwrite(statement,qsize+msize+4,1,ziel);
        free(statement);
        free(quelle);
        free(methode);

        //nchste zeile aus der quelldatei einlesen
        if(!getLine(&datei))
          break;
          
        //zeit einlesen
        scanLine();

        //dateinamen einlesen und speichern
        scanLine();
        qsize = size;
        quelle = (char *)malloc(qsize+1);
        strncpy(quelle,symbol,qsize+1);

        //methodennamen einlesen und speichern
        scanLine();
        msize = size;
        methode = (char *)malloc(msize+1);
        strncpy(methode,symbol,msize+1);

        //quelldatei zeilenweise einlesen (& in ausgabedatei schreiben)
        //bis syncronisationsbasis gefunden
        while((strcmp(quelle,syncquelle) != 0) || (strcmp(methode,syncmethode) != 0))
        {//in ausgabedatei schreiben
          statement = (char *)malloc(qsize+msize+5);
          *statement = '\0';
		  strncat(statement,"\t\t",2);
          strncat(statement,quelle,qsize);
          strncat(statement,"\t\t",2);
          strncat(statement,methode,msize);
          fwrite(statement,qsize+msize+4,1,ziel);
          free(statement);
          free(quelle);
          free(methode);

          //nchste zeile aus der quelldatei einlesen
          if(!getLine(&datei))
		  {//dateiende der quelldatei erreicht
			  dateiende = 1;
			  break;
		  }
          
          //zeit einlesen
          scanLine();

          //dateinamen einlesen und speichern
          scanLine();
          qsize = size;
          quelle = (char *)malloc(qsize+1);
          strncpy(quelle,symbol,qsize+1);

          //methodennamen einlesen und speichern
          scanLine();
          msize = size;
          methode = (char *)malloc(msize+1);
          strncpy(methode,symbol,msize+1);
        }
        //synchronisationsbasis gefunden => normal weiterverfahren
      }

      free(syncquelle);
      free(syncmethode);

	  if(!dateiende)
	  {
		free(quelle);
		free(methode);
	  }
    }
    else
    {//dateiende der referenzdatei erreicht => den rest der quelldatei
	 //in die ausgabedatei schreiben
      statement = (char *)malloc(qsize+msize+5);
      *statement = '\0';
	  strncat(statement,"\t\t",2);
      strncat(statement,quelle,qsize);
      strncat(statement,"\t\t",2);
      strncat(statement,methode,msize);
      fwrite(statement,qsize+msize+4,1,ziel);
      free(statement);
      free(quelle);
      free(methode);

      while(getLine(&datei))      
      {
        //zeit einlesen
        scanLine();

        //dateinamen einlesen und speichern
        scanLine();
        qsize = size;
        quelle = (char *)malloc(qsize+1);
        strncpy(quelle,symbol,qsize+1);

        //methodennamen einlesen und speichern
        scanLine();
        msize = size;
        methode = (char *)malloc(msize+1);
        strncpy(methode,symbol,msize+1);
        
        statement = (char *)malloc(qsize+msize+5);
        *statement = '\0';
		strncat(statement,"\t\t",2);
        strncat(statement,quelle,qsize);
        strncat(statement,"\t\t",2);
        strncat(statement,methode,msize);
        fwrite(statement,qsize+msize+4,1,ziel);
        free(statement);
        free(quelle);
        free(methode);
      }
    }
  }

  free(buffer);
  free(symbol);
  fclose(datei);
  fclose(rdatei);
  fclose(ziel);
  
  printf("fertig\n");
  return (0);
}
